#ifndef ALL_PROCESSINGS__HPP
#define ALL_PROCESSINGS__HPP

#ifdef HDRIP_EXPORTS
#define HDRIP_API __declspec(dllexport)
#else
#define HDRIP_API __declspec(dllimport)
#endif

extern "C" {
  HDRIP_API float* exposure(float* data, unsigned int width, unsigned int height, float exposure);

  HDRIP_API float* contrast(float* data, unsigned int width, unsigned int height, float contrast);

  HDRIP_API float* yCurve(float* data, unsigned int width, unsigned int height, float yCs, float yCb, float yCm, float yCw, float yCh);

  HDRIP_API float* lightnessMask(float* data, unsigned int width, unsigned int height, bool lms, bool lmb, bool lmm, bool lmw, bool lmh);

  HDRIP_API float* saturation(float* data, unsigned int width, unsigned int height, float saturation);

  HDRIP_API float* colorEditor(float* data, unsigned int width, unsigned int height, float ce_sel_light_l, float ce_sel_light_h, float ce_sel_chr_l, float ce_sel_chr_h, float ce_sel_hue_l, float ce_sel_hue_h, float ce_tol, float ce_edit_hue, float ce_edit_expo, float ce_edit_con, float ce_edit_sat, bool ce_mask);

  HDRIP_API float* full_process(float* data, unsigned int width, unsigned int height,
    float exposure,
    float contrast,
    float yCs, float yCb, float yCm, float yCw, float yCh,
    bool lms, bool lmb, bool lmm, bool lmw, bool lmh,
    float saturation,
    float ce_sel_light_l, float ce_sel_light_h, float ce_sel_chr_l, float ce_sel_chr_h, float ce_sel_hue_l, float ce_sel_hue_h, float ce_tol, float ce_edit_hue, float ce_edit_expo, float ce_edit_con, float ce_edit_sat, bool ce_mask);
}

#endif